#include <tcl.h>
#include <stdio.h>

class A {
public:
  A (const char *);
};

A::A (const char * msg)
{
  printf ("%s\n", msg);
}

A a ("Global constructor okay.");

extern "C" {
int
Module_Init (Tcl_Interp * interp)
{
  printf ("Hello World\n");

#ifdef CONSTR
  extern void _GLOBAL__DI ();
  _GLOBAL__DI ();
#endif

#ifdef CTORLIST
  typedef void entry_pt();
  extern entry_pt * __CTOR_LIST__[];
  entry_pt ** iter = __CTOR_LIST__;
  for (++iter; *iter; iter++) {
   (*iter) ();
  }
#endif

  return TCL_OK;
}
}
